/*                                                                                       */
/*                 OUT.C by Andrew I. Reshin. Last modified 13.07.2000.                  */
/*       Get a text from stdin, convert from/to *any* codepage and put to stdout.        */
/*                                                                                       */
/* NB: Double byte characters that looks like {0xD0,0x90..0xBF} || {0xD1,0x80..0x8F} are */
/* probably UTF-8 (CP 65001) - new system default CP, also CP 20866 is equal to KOI8-R.  */
/*                                                                                       */

#include <windows.h>
#include <stdio.h>

int main(int argc,char **argv)
{
UINT cpout,cpin;
HANDLE hout,hin;
LPSTR endptr;
char buf[1024];
WCHAR wbuf[1024];
DWORD readlen,writelen,num;
BOOL isok;

cpin=cpout=CP_OEMCP;

if(argc>1)
 {
 cpin=strtoul(argv[1],&endptr,0);
 isok=(endptr!=argv[1]);

 if(isok && argc>2)
  {
  cpout=strtoul(argv[2],&endptr,0);
  isok=(endptr!=argv[2]);
  }

 if(!isok)
  {
  printf(
	"\n Usage: %s [<input codepage> [output codepage]]\n"
	" System default codepages: ANSI (%d), MAC (%d) and OEM (%d)\n"
	,argv[0],CP_ACP,CP_MACCP,CP_OEMCP
	);
  return 1;
 }}

hin=GetStdHandle(STD_INPUT_HANDLE);
hout=GetStdHandle(STD_OUTPUT_HANDLE);

if(hin==INVALID_HANDLE_VALUE || hout==INVALID_HANDLE_VALUE) return 2;
if(WaitForSingleObject(hin,0)!=WAIT_OBJECT_0) return 0;

while(ReadFile(hin,buf,sizeof(buf)/2,&readlen,0) && readlen)
 {
 if(cpin!=cpout || cpin!=CP_OEMCP)
  {
  num=MultiByteToWideChar(cpin,0,buf,readlen,wbuf,sizeof(wbuf)/sizeof(WCHAR));
  if(!num) return 3;
  num=WideCharToMultiByte(cpout,0,wbuf,num,buf,sizeof(buf),0,0);
  if(!num) return 4;
  }
 else num=readlen;

 if(!WriteFile(hout,buf,num,&writelen,0)) return 5;
 }

return 0;
}

